; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

Rand MACRO range
LOCAL oa
  mov eax, Initial	; Initial
  imul eax, 127	; randomise
  add eax, 127
  bswap eax	; we need the high order bits
  mov Initial, eax	; save for next round
  oa = (opattr range) AND 127
  if oa eq 36
	if range ge -128 and range le 127
		push range
		pop edx
	else
		mov edx, range	; multiply Initial
	endif
  else
	mov edx, range	; multiply Initial
  endif
  mul edx		; with range
  EXITM <edx>	; return random number
ENDM

.data
Initial dd "RAND"

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	RepCt =	10		; multiple timings prevent negative cycles ;-)
	REPEAT 3
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
				push 1000
				call Axrand
				mov ecx, eax
			ENDM
		counter_end
	print str$(eax), 9, "cycles for "
	print str$(RepCt), "*Axrand", 13, 10
;		invoke Sleep, SleepMs
;		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		REPEAT RepCt
;				push 1000
;				call Axrand2
;				mov ecx, eax
;			ENDM
;		counter_end
;	print str$(eax), 9, "cycles for "
;	print str$(RepCt), "*Axrand2", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
				push 1000
				call Axrand3
				mov ecx, eax
			ENDM
		counter_end
	print str$(eax), 9, "cycles for "
	print str$(RepCt), "*Axrand3", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
				push 1000
				call LimitRand
				mov ecx, eax
			ENDM
		counter_end
	print str$(eax), 9, "cycles for "
	print str$(RepCt), "*LimitRand", 13, 10
	
	
	
			invoke Sleep, SleepMs
			xor esi, esi
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
				call ASeed
				mov ecx, eax
			ENDM
		counter_end
	print str$(eax), 9, "cycles for "
	print str$(RepCt), "*ASeed", 13, 10
;	print str$(esi), " times QPC", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
				mov ecx, Rand(1000)
			ENDM
		counter_end
	print str$(eax), 9, "cycles for "
	print str$(RepCt), "*Rand()", 13, 10
		print chr$(13, 10)
	ENDM
	CodeSize Axrand
;	CodeSize Axrand2
	CodeSize Axrand3
	CodeSize ASeed
	CodeSize LimitRand
s1:
		mov ecx, Rand(1000)
e1:		mov eax, e1
		sub eax, s1
		sub eax, 2		; correct for mov ecx, ...
		print str$(eax), 9, " bytes for Rand()", 13, 10, "Add 7-10 bytes per call", 13, 10
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16	
Axrand_s:
Axrand proc STDCALL dwRange:DWORD
		;int 3
		mov edx,Initial
		mov eax,Initial
		imul edx,12347
		add edx,17
		bswap edx
		mov Initial,edx
		mul dword ptr [esp+4]
		mov eax,edx
		ret 4
Axrand endp
Axrand_endp:

align 16	
Axrand2_s:
Axrand2 proc STDCALL dwRange:DWORD
	push ecx
	mov ecx, offset Initial
	mov eax, [ecx]	; multiply Initial
	mul dword ptr [esp+8]	; with range
	mov eax, edx	; return random number
	mov edx, [ecx]	; Initial
	imul edx, 127
	add edx, 127
	bswap edx
	mov [ecx], edx	; Initial
	pop ecx
	ret 4
Axrand2 endp
Axrand2_endp:

align 16	
Axrand3_s:
Axrand3 proc STDCALL dwRange:DWORD	; 27 bytes short
	mov eax, Initial	; get the seed
	imul eax, -127	; randomise
	add eax, -124	; -127/-124 is the perfect randomness pair
	bswap eax	; we need to shuffle a bit to get the high order bits
	mov Initial, eax	; save for next round
	mul dword ptr [esp+4]	; multiply Initial with range
	mov eax, edx	; return random number (could also be returned in edx)
	ret 4
Axrand3 endp
Axrand3_endp:

align 16	
Axrand4_s:
Axrand4 proc STDCALL dwRange:DWORD
		mov eax, Initial
		push eax
		mul dword ptr [esp+8]
		mov eax, edx
		pop edx
		imul edx, 127
		add edx, 127
		bswap edx
		mov Initial, edx
		ret 4
Axrand4 endp
Axrand4_endp:

.data
Rand32  DD      31415926        ; a la K
        DD      1013904223      ; As per NR RandC
RandA   DD      1517746329      ; See RandMWC
.code
align 16
LimitRand_s:
LimitRand:
        MOV     EAX,[Rand32]
        MUL     dword ptr [esp+4]
        MOV     ECX,EDX
; - - - - - -
RandMWC:
        MOV     EAX,[Rand32]
        MUL     [RandA]
        ADD     EAX,[Rand32+4]
        ADC     EDX,0
        MOV     [Rand32],EAX
        MOV     [Rand32+4],EDX
        mov eax,ecx
        RET 4
LimitRand_endp:
        

.data        
SeedCnt dd      1
.data?
Rnd32hi dd      ?
Rnd32lo dd      ?
.code

align 16
ASeed_s:
ASeed   PROC

        dec     SeedCnt
        jnz     ASeed0

        INVOKE  QueryPerformanceCounter,offset Rnd32hi
;        inc esi
        movzx   eax,byte ptr Rnd32lo
        or      al,80h
        mov     SeedCnt,eax

ASeed0: mov     edx,1517746329
        mov     eax,Rnd32lo
        mul     edx
        add     eax,Rnd32hi
        adc     edx,0
        mov     Rnd32lo,eax
        mov     Rnd32hi,edx
        ret

ASeed   ENDP
ASeed_endp:


OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]